Package com.io7m.cardant.model

# Record Class CATypeScalarType.Monetary

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CATypeScalarType.Monetary

Record Components:
  `name` - The type name
  `description` - A humanly-readable description of the type
  `rangeLower` - The lower bound (inclusive)
  `rangeUpper` - The upper bound (inclusive)

All Implemented Interfaces:
  `CATypeScalarType`

Enclosing interface:
  `CATypeScalarType`

public static record CATypeScalarType.Monetary(com.io7m.lanark.core.RDottedName name, String description, BigDecimal rangeLower, BigDecimal rangeUpper) extends Record implements CATypeScalarType
A monetary type.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface com.io7m.cardant.model.CATypeScalarType

  `CATypeScalarType.Integral, CATypeScalarType.Kind, CATypeScalarType.Monetary, CATypeScalarType.Real, CATypeScalarType.Text, CATypeScalarType.Time`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Monetary(com.io7m.lanark.core.RDottedName name, String description, BigDecimal rangeLower, BigDecimal rangeUpper)`
  A monetary type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `boolean`
  `isValid(BigDecimal value)`
  `CATypeScalarType.Kind`
  `kind()`
  `com.io7m.lanark.core.RDottedName`
  `name()`
  Returns the value of the `name` record component.
  `BigDecimal`
  `rangeLower()`
  Returns the value of the `rangeLower` record component.
  `BigDecimal`
  `rangeUpper()`
  Returns the value of the `rangeUpper` record component.
  `String`
  `showConstraint()`
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Monetary

    public Monetary(com.io7m.lanark.core.RDottedName name, String description, BigDecimal rangeLower, BigDecimal rangeUpper)
    A monetary type.

- ## Method Details

  - ### showConstraint

    public String showConstraint()
    Specified by:
      `showConstraint` in interface `CATypeScalarType`
    Returns:
      A humanly-readable description of this type's value constraints

  - ### kind

    public CATypeScalarType.Kind kind()
    Specified by:
      `kind` in interface `CATypeScalarType`
    Returns:
      The internal type kind

  - ### isValid

    public boolean isValid(BigDecimal value)
    Parameters:
      `value` - The value
    Returns:
      `true` if the given value is in the range for this type

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public com.io7m.lanark.core.RDottedName name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `CATypeScalarType`
    Returns:
      the value of the `name` record component

  - ### description

    public String description()
    Returns the value of the `description` record component.
    Specified by:
      `description` in interface `CATypeScalarType`
    Returns:
      the value of the `description` record component

  - ### rangeLower

    public BigDecimal rangeLower()
    Returns the value of the `rangeLower` record component.
    Returns:
      the value of the `rangeLower` record component

  - ### rangeUpper

    public BigDecimal rangeUpper()
    Returns the value of the `rangeUpper` record component.
    Returns:
      the value of the `rangeUpper` record component